| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Member Functions | Static Public Attributes | List of all members
Ogre::Volume::GridSource Class Referenceabstract
Optional Components » Volume

A volume source from a discrete 3d grid. More...

`#include <OgreVolumeGridSource.h>`

Inheritance diagram for Ogre::Volume::GridSource:
[legend]

## Public Member Functions
| GridSource (bool trilinearValue, bool trilinearGradient, bool sobelGradient)
virtual | ~GridSource (void)
| Destructor. More...
virtual void | combineWithSource (CSGOperationSource *operation, Source *source, const Vector3 &center, Real radius)
| Updates this grid with another source in a certain area. More...
size_t | getDepth (void) const
| Gets the depth of the texture. More...
bool | getFirstRayIntersection (const Ray &ray, Vector3 &result, Real scale=(Real) 1.0, size_t maxIterations=5000, Real maxDistance=(Real) 10000.0) const
| Gets the first intersection of a ray with the volume. More...
size_t | getHeight (void) const
| Gets the height of the texture. More...
virtual Real | getValue (const Vector3 &position) const
| Overridden from VolumeSource. More...
virtual Vector4 | getValueAndGradient (const Vector3 &position) const
| Overridden from VolumeSource. More...
Real | getVolumeSpaceToWorldSpaceFactor (void) const
| Overridden from VolumeSource. More...
size_t | getWidth (void) const
| Gets the width of the texture. More...
void | serialize (const Vector3 &from, const Vector3 &to, float voxelWidth, const String &file)
| Serializes a volume source to a discrete grid file with deflated compression. More...
void | serialize (const Vector3 &from, const Vector3 &to, float voxelWidth, Real maxClampedAbsoluteDensity, const String &file)
| Same as the other serialize function but with a user definable maximum absolute density value. More...

## Static Public Attributes
static const size_t | SERIALIZATION_CHUNK_SIZE
| The amount of items being written as one chunk during serialization. More...
static const uint32 | VOLUME_CHUNK_ID
| The id of volume files. More...
static const uint16 | VOLUME_CHUNK_VERSION
| The version of volume files. More...

## Detailed Description

A volume source from a discrete 3d grid.

## Constructor & Destructor Documentation

## ◆ GridSource()

Ogre::Volume::GridSource::GridSource | ( | bool | trilinearValue,
|  | bool | trilinearGradient,
|  | bool | sobelGradient
| ) |  |

## ◆ ~GridSource()

virtual Ogre::Volume::GridSource::~GridSource | ( | void |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ getValueAndGradient()

virtual Vector4 Ogre::Volume::GridSource::getValueAndGradient | ( | const Vector3 & | position | ) | const
| virtual

Overridden from VolumeSource.

Implements Ogre::Volume::Source.

## ◆ getValue()

virtual Real Ogre::Volume::GridSource::getValue | ( | const Vector3 & | position | ) | const
| virtual

Overridden from VolumeSource.

Implements Ogre::Volume::Source.

## ◆ getWidth()

size_t Ogre::Volume::GridSource::getWidth | ( | void |  | ) | const

Gets the width of the texture.

Returns
  The width of the texture.

## ◆ getHeight()

size_t Ogre::Volume::GridSource::getHeight | ( | void |  | ) | const

Gets the height of the texture.

Returns
  The height of the texture.

## ◆ getDepth()

size_t Ogre::Volume::GridSource::getDepth | ( | void |  | ) | const

Gets the depth of the texture.

Returns
  The depth of the texture.

## ◆ combineWithSource()

virtual void Ogre::Volume::GridSource::combineWithSource | ( | CSGOperationSource * | operation,
|  | Source * | source,
|  | const Vector3 & | center,
|  | Real | radius
| ) |  |
| virtual

Updates this grid with another source in a certain area.

Use it for example to add spheres as a brush.

Parameters

  operation | The operation to use, will use this source and the other given one as operands. Beware that this function overrides the maybe existing sources in the operation.
  source | The other source to combine this one with.
  center | The rough center of the affected area by the operation. If the other source is a sphere, take its center for example.
  radius | The radius of the affected area. For the example sphere, you might use its radius times two because the density outside of the sphere is needed, too.

## ◆ getVolumeSpaceToWorldSpaceFactor()

Real Ogre::Volume::GridSource::getVolumeSpaceToWorldSpaceFactor | ( | void |  | ) | const

Overridden from VolumeSource.

## ◆ serialize() [1/2]

void Ogre::Volume::Source::serialize | ( | const Vector3 & | from,
|  | const Vector3 & | to,
|  | float | voxelWidth,
|  | const String & | file
| ) |  |
| inherited

Serializes a volume source to a discrete grid file with deflated compression.

To achieve better compression, all density values are clamped within a maximum absolute value of (to - from).length() / 16.0. The values are scanned in this inner-loop-order: z, x, y. y last because there is usually the least isosurface intersection to be expected in the use case of terrain and so more often the maximum density value hit. The values are written as 16 Bit floats to save space. Note that this process is not lossless, the tradeoff is between accuracy of the source-reproduction (smaller voxelWidth) and smaller filesize (bigger voxelWidth).

Parameters

  from | The start point to scan the volume.
  to | The end point to scan the volume.
  voxelWidth | The width of a single cube in the density grid.
  file | The file to write the grid to.

## ◆ serialize() [2/2]

void Ogre::Volume::Source::serialize | ( | const Vector3 & | from,
|  | const Vector3 & | to,
|  | float | voxelWidth,
|  | Real | maxClampedAbsoluteDensity,
|  | const String & | file
| ) |  |
| inherited

Same as the other serialize function but with a user definable maximum absolute density value.

Parameters

  from | The start point to scan the volume.
  to | The end point to scan the volume.
  voxelWidth | The width of a single cube in the density grid.
  maxClampedAbsoluteDensity | The maximum absolute density value to be written into the file, influencing the compression rate.
  file | The file to write the grid to.

## ◆ getFirstRayIntersection()

bool Ogre::Volume::Source::getFirstRayIntersection | ( | const Ray & | ray,
|  | Vector3 & | result,
|  | Real | scale = `(Real) 1.0`,
|  | size_t | maxIterations = `5000`,
|  | Real | maxDistance = `(Real) 10000.0`
| ) |  | const
| inherited

Gets the first intersection of a ray with the volume.

If you are using this together with the VolumeChunk: Beware of the possible scaling or other transformations you did on the Chunk! Do the inverse first on the ray origin. Example of a scaling with the factor 10: ray.setOrigin(ray.getOrigin() / (Real)10.0);

Parameters

  ray | The ray.
  result | Will hold the intersection point if there is an intersection.
  scale | The scaling of the volume compared to the world.
  maxIterations | The maximum amount of iterations on the ray before giving up.
  maxDistance | The maximum distance of the intersection point.

## Member Data Documentation

## ◆ VOLUME_CHUNK_ID

const uint32 Ogre::Volume::Source::VOLUME_CHUNK_ID
| static inherited

The id of volume files.

## ◆ VOLUME_CHUNK_VERSION

const uint16 Ogre::Volume::Source::VOLUME_CHUNK_VERSION
| static inherited

The version of volume files.

## ◆ SERIALIZATION_CHUNK_SIZE

const size_t Ogre::Volume::Source::SERIALIZATION_CHUNK_SIZE
| static inherited

The amount of items being written as one chunk during serialization.

The documentation for this class was generated from the following file:

- OgreVolumeGridSource.h